Description

Currently the UriBuilder does not reliably support SubRequests and it has some flaws, that should be fixed.
Some facts:

¢ setRequest() resets the UriBuilder ($this->reset()) - correct
¢ setRequest() expects an \F3\FLOW3\MVC\RequestInterface - should be \F3\FLOW3\MVC\Web\Request !?

¢ setArguments() prefixes specified arguments, if argumentPrefix is not empty - incorrect, setArguments should be a simple
setter for $this->arguments

e getArgments() returns all arguments, including non-prefixed - correct, if setter is fixed
¢ setFormat() stores the specified format string lower cased - probably ok

¢ setArgumentPrefix() (non-api) "Specifies the prefix to be used for all arguments." - should be reramed-to
setGontrolferArgumentPrefix{() removed. Prefix comes from Request:.getArgumentNamespace()

* reset() sets argument prefix and all arguments of the parent request if $this->request is a SubRequest - incorrect. reset(9
should completely reset the UriBuilder (except for the request). parent request arguments should be added in build()

« uriFor() modifies $this->arguments - incorrect, modified arguments should be passed to build() as method arguments

Related issues:
Blocks Conference Management - Story #26663: Solve FLOW3/Phoenix bugs for spr... Resolved 2011-05-06

Associated revisions

Revision 1174777f - 2011-05-10 11:10 - Bastian Waidelich
[+BUGFIX] Fix and cleanup UriBuilder

This is mainly a refactoring of the UriBuilder.

But there are some slight changes in behavior too:

1. setRequest() now expects an instance of F3\FLOW3\MVC\Web\Request,
not F3\FLOW3\MVC\RequestInterface

2. $this-arguments is not modified by any method apart

from setArguments() and reset()

3. setArgumentPrefix() (not part of the api) is removed,

the argument prefix is determined by the request instead

Change-Id: 1182e892857bc50cbbed754055d8bccb2fe5ac508
Resolves: #26662

History

#1 - 2011-05-06 11:00 - Bastian Waidelich
- Parent task set to #26663

#2 - 2011-05-06 11:03 - Bastian Waidelich
- Parent task deleted (#26663)
#3 - 2011-05-06 11:25 - Karsten Dambekalns

- Target version deleted (Call for Papers)

#4 - 2011-05-06 11:36 - Bastian Waidelich

Matrix for expected behavior:
https://spreadsheets.google.com/ccc?key=0AIDROZpGJKkldHpvMkhocihQVXZfY mxoekxERU9Da0E&hl=en&authke

#5 - 2011-05-09 11:03 - Mr. Hudson

Patch set 1 of change 118ae892857bc50cbbed754055d8bccb2fe5ac508 has been pushed to the review server.

It is available at http:/review.typo3.org/1960

#6 - 2011-05-09 11:06 - Mr. Hudson

Patch set 2 of change 118ae892857bc50cbbed754055d8bccb2fe5ac508 has been pushed to the review server.

It is available at http://review.typo3.org/1960

#7 - 2011-05-09 19:44 - Mr. Hudson

Patch set 3 of change 118ae892857bc50cbbed754055d8bccb2fe5ac508 has been pushed to the review server.

It is available at http:/review.typo3.0rg/1960

#8 - 2011-05-09 19:49 - Mr. Hudson

Patch set 4 of change 118ae892857bc50cbbed754055d8bccb2fe5ac508 has been pushed to the review server.

It is available at http://review.typo3.org/1960

#9 - 2011-05-10 11:13 - Mr. Hudson

Patch set 5 of change 118ae892857bc50cbbed754055d8bccb2fe5ac508 has been pushed to the review server.

It is available at http://review.typo3.org/1960

#10 - 2011-05-10 11:35 - Bastian Waidelich
- Status changed from Accepted to Resolved

- % Done changed from 0 to 100

Applied in changeset 1174777fe9eae9654c2e4d3aaed4eae0153e65277.
